/**
 *  @file   NamedElement.java
 *  @brief  Provide a name.
 *  @author prometheus@btc-es.de
 *
 *  --------------------------------------------------------- 
 *  Copyright (c) 2014, 
 *  BTC Embedded Systems AG, Oldenburg, Germany  
 *  All rights reserved
 *  --------------------------------------------------------- 
 *  $Author: myname $
 *  $Date: 2014-09-24 10:32:35 +0200 (Mi, 24 Sep 2014) $
 *  $Revision: 452 $
 **/
package com.btc.ep.base.bl;

/**
 * A Named Element is simply a name with a name attribute. Concrete classes
 * that should have a name, should extend this class.
 * 
 * @author stefanh
 */
public abstract interface NamedElement extends ModelElement {

    /**
     * Get the name.
     * 
     * @return The name, must not be null
     */
    public String getName();

    /**
     * Set the name
     * 
     * @param name The name to be set.
     */
    public void setName(String name);
}
