/**
 *  @file   Profile.java
 *  @brief  A profile is a ... // TODO explain in detail
 *  @author prometheus-team
 *
 *  --------------------------------------------------------- 
 *  Copyright (c) 2014, 
 *  BTC Embedded Systems AG, Oldenburg, Germany  
 *  All rights reserved
 *  --------------------------------------------------------- 
 *  $Author:  $
 *  $Date: $
 *  $Revision: $
 **/
package com.btc.ep.base.bl;

import java.io.File;

/**
 * Implementors of this interface represent Profiles.
 */
public interface Profile extends NamedElement {

    /**
     * Get the file path location for the saved profile.
     * 
     * @return The file in which the profile is saved.
     */
    File getFilePath();

    /**
     * Set the file path location for the profile saving.
     * 
     * @param filepath The file in which the profile is saved.
     */
    void setFilePath(File filepath);
    //
    //    /**
    //     * Add a message to the profile.
    //     * 
    //     * @param msg The message to be added.
    //     */
    //    public void addMessage(Message msg);
    //
    //    /**
    //     * Deletes all stored messages.
    //     */
    //    public abstract void clearMessages();
    //
    //    /**
    //     * Deletes all stored messages regarding a causing ModelElement.
    //     * 
    //     * @param causingObject The ModelElement which is the cause of the message to clear.
    //     */
    //    public abstract void clearMessages(ModelElement causingObject);
    //    
    /**
     * Add a mapping to the profile.
     * 
     * @param map The mapping to be added.
     */
    public void addMapping(Mapping map);
    
    /**
     * Remove a mapping from a profile.
     * 
     * @param map The mapping to be removed.
     */
    public void removeMapping(Mapping map);
    //
    //    /**
    //     * Persist the Profile in the DataBase.
    //     */
    //    void save();
}
