/**
 *  Copyright (c) 2014, 
 *  BTC Embedded Systems AG, Oldenburg, Germany  
 *  All rights reserved
 *  --------------------------------------------------------- 
 *  $Author: $
 *  $Date:  $
 *  $Revision: $
 **/

package com.btc.ep.base.bl.impl;

import java.util.ArrayList;
import java.util.List;

import com.btc.ep.base.bl.Mapping;
import com.btc.ep.base.bl.ModelElement;

// ---------------------------------------------------------------------------
// Implementation
// ---------------------------------------------------------------------------

/**
 * This class implements the Mapping
 */
public class MappingImpl extends NamedElementImpl implements Mapping {

    private String key;

    private String kind;

    private List<ModelElement> values = new ArrayList<ModelElement>();

    /**
     * Create an object
     */
    public MappingImpl() {
    }

    public MappingImpl(String key) {
        this.key = key;
    }

    @Override
    public String getKey() {
        return this.key;
    }

    @Override
    public void setKind(String kind) {
        if (kind == null || kind.isEmpty()) {
            throw new IllegalArgumentException("Kind attribute of a Mapping object must not be null.");
        }
        this.kind = kind;
    }

    @Override
    public String getKind() {
        return kind;
    }

    @Override
    public boolean containsValue(ModelElement value) {
        return values.contains(value);
    }

    @Override
    public List<ModelElement> getValues() {
        return values;
    }

    @Override
    public void addValue(ModelElement value) {
        this.values.add(value);
    }

    @Override
    public void removeValue(ModelElement value) {
        this.values.remove(value);

    }

    @Override
    public <T extends ModelElement> List<ModelElement> getValues(Class<T> value) {
        return this.values;
    }
}

// ---------------------------------------------------------------------------
// END OF FILE
// ---------------------------------------------------------------------------