/**
 * 
 */
package com.btc.ep.requirement.bl.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.btc.ep.base.bl.impl.NamedElementImpl;
import com.btc.ep.requirement.bl.Requirement;
import com.btc.ep.requirement.bl.RequirementsSource;

/**
 * Implements the RequirementsSource domain model object interface
 * 
 * @author stefanh
 */
public class RequirementsSourceImpl extends NamedElementImpl implements RequirementsSource {

    private String kind;

    private List<Requirement> reqs;

    private Map<String, String> settings = new HashMap<String, String>();

    /**
     * Default Constructor
     */
    public RequirementsSourceImpl() {
    }

    @Override
    public String getSetting(String key) {
        return settings.get(key);
    }

    @Override
    public void addSetting(String key, String value) {
        this.settings.put(key, value);
    }

    @Override
    public String getKind() {
        return kind;
    }

    @Override
    public void setKind(String kind) {
        this.kind = kind;
    }

    @Override
    public List<Requirement> getRequirements() {
        if (this.reqs == null) {
            this.reqs = new ArrayList<Requirement>();
        }
        return this.reqs;
    }

    @Override
    public void addRequirement(Requirement req) {
        if (this.reqs == null) {
            this.reqs = new ArrayList<Requirement>();
        }
        this.reqs.add(req);
    }

    @Override
    public Map<String, String> getSettings() {
        return this.settings;
    }

    @Override
    public Requirement getRequirementByName(String name) {
        for (Requirement req : this.reqs) {
            if (req.getName().equals(name)) {
                return req;
            }
        }
        return null;
    }
}
