package com.btc.ep.base.dal.tests.it;

import java.io.File;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import com.btc.ep.base.bl.Profile;
import com.btc.ep.base.bl.impl.ProfileImpl;
import com.btc.ep.requirement.bl.Requirement;
import com.btc.ep.requirement.bl.RequirementsSource;
import com.btc.ep.requirement.bl.impl.RequirementImpl;
import com.btc.ep.requirement.bl.impl.RequirementImpl10;
import com.btc.ep.requirement.bl.impl.RequirementImpl11;
import com.btc.ep.requirement.bl.impl.RequirementImpl2;
import com.btc.ep.requirement.bl.impl.RequirementImpl3;
import com.btc.ep.requirement.bl.impl.RequirementImpl4;
import com.btc.ep.requirement.bl.impl.RequirementImpl5;
import com.btc.ep.requirement.bl.impl.RequirementImpl6;
import com.btc.ep.requirement.bl.impl.RequirementImpl7;
import com.btc.ep.requirement.bl.impl.RequirementImpl8;
import com.btc.ep.requirement.bl.impl.RequirementImpl9;
//import com.btc.ep.requirement.bl.impl.RequirementImpl10;
//import com.btc.ep.requirement.bl.impl.RequirementImpl11;
//import com.btc.ep.requirement.bl.impl.RequirementImpl2;
//import com.btc.ep.requirement.bl.impl.RequirementImpl3;
//import com.btc.ep.requirement.bl.impl.RequirementImpl4;
//import com.btc.ep.requirement.bl.impl.RequirementImpl5;
//import com.btc.ep.requirement.bl.impl.RequirementImpl6;
//import com.btc.ep.requirement.bl.impl.RequirementImpl7;
//import com.btc.ep.requirement.bl.impl.RequirementImpl8;
//import com.btc.ep.requirement.bl.impl.RequirementImpl9;
import com.btc.ep.requirement.bl.impl.RequirementsSourceImpl;

/**
 * This class tests the DAL save and load operations.
 */

public class IT_DALSaveAndLoadTest {

	/**
	 * initializes resources before running all tests
	 * 
	 * @throws Exception
	 *             anything
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * destroys resources after running all tests
	 * 
	 * @throws Exception
	 *             anything
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * initializes before running a particular test
	 * 
	 * @throws Exception
	 *             anything
	 */
	@Before
	public void setUp() throws Exception {
	}

	/**
	 * destroys after running a particular test
	 * 
	 * @throws Exception
	 *             anything
	 */
	@After
	public void tearDown() throws Exception {
	}

	/**
	 * Saves a profile, loads a profile and compares the saved profile to the
	 * load profile. A log in the console explains the tree comparing.
	 *
	 * @throws Exception
	 *             anything
	 */
	@Test
	public void saveProfileAndLoadProfileAndComparingProfilesTest()
			throws Exception {
		
		EntityManagerFactory provider = Persistence.createEntityManagerFactory("eppdb");
		
		EntityManager entityManager = provider.createEntityManager();		
		entityManager.getTransaction().begin();

		Profile profile = new ProfileImpl();

		profile.setFilePath(new File("abc.txt"));
		profile.setName("profile");
		
		entityManager.persist(profile);
		
		RequirementsSource requirementsSource = new RequirementsSourceImpl();
		Requirement requirement = new RequirementImpl(requirementsSource);
		requirement.setDescription("description");
		entityManager.persist(requirementsSource);

		profile = entityManager.merge(profile);

		entityManager.remove(profile);
		
		entityManager.merge(new RequirementImpl(requirementsSource));
		entityManager.merge(new RequirementImpl2(requirementsSource));
		entityManager.merge(new RequirementImpl3(requirementsSource));
		entityManager.merge(new RequirementImpl4(requirementsSource));
		entityManager.merge(new RequirementImpl5(requirementsSource));
		entityManager.merge(new RequirementImpl6(requirementsSource));
		entityManager.merge(new RequirementImpl7(requirementsSource));
		entityManager.merge(new RequirementImpl8(requirementsSource));
		entityManager.merge(new RequirementImpl9(requirementsSource));
		entityManager.merge(new RequirementImpl10(requirementsSource));
		entityManager.merge(new RequirementImpl11(requirementsSource));

		entityManager.getTransaction().commit();

	}

}
